#!/usr/bin/perl
###
use FindBin;
use lib $FindBin::Bin;
use Compress::Zlib;
use Data::Dumper;
use DBI;
###
$ConfFile='./msas.conf';
$InfoFile='./msas.info';
$LockFile='./msas.lock';
$DateList='./date.js';
$DataDir='./log/';
$DbDir='./db/';
$MaxList=1000;
$LogExpires=5;
#$InsertType=1;
$Logfile1='/var/log/apache2/other_vhosts_access.log';
$Logfile2='/var/log/apache2/other_vhosts_access.log.1';
###
open(LOCK,"+>$LockFile");
flock(LOCK,2);
my $start=time;
&ReadConf;
do($InfoFile);
$LastUpdate=(stat($InfoFile))[9];
&Analize($Logfile2);
&Analize($Logfile1);
&WriteInfo;
&WriteDate if($Info{'CurrentDate'});
&DateList;
print LOCK (time-$start);
close(LOCK);
###
sub ReadConf{
	my(@line);
	open(FILE,$ConfFile);
	while(<FILE>){
		next if(/^#/);
		s/[\r\n]//g;
		@line=split(/>/,$_,2);
		next if(!$line[1]);
		if($line[0] eq 'page'){
			push(@{$Conf{'page'}},$line[1]);
		}elsif($line[0] eq 'nopage'){
			@line=split(/>/,$line[1],2);
			push(@{$Conf{'nopage'}{$line[0]}},$line[1]);
		}elsif($line[0] eq 'noerror'){
			@line=split(/>/,$line[1],3);
			@{$Conf{'noerror'}[$#{$Conf{'noerror'}}+1]}=@line;
		}elsif($line[0] eq 'custom'){
			@line=split(/>/,$line[1],4);
			@{$Conf{'custom'}}=@line;
		}
	}
	close(FILE);
}
###
sub WriteInfo{
	${Data::Dumper::Terse}=1;
	${Data::Dumper::Indent}=0;
	open(FILE,"+>$InfoFile");
	print FILE "\%Data=\%{".Dumper(\%Data)."};\n";
	print FILE "\%Info=\%{".Dumper(\%Info)."};\n";
	close(FILE);
}
###
sub DateList{
	my(@list);
	opendir(DIR,"$DataDir");
	foreach(readdir(DIR)){
		if(/^(\d+)\.jgz$/){
			push(@list,"'$1'");
		}
	}
	closedir(DIR);
	open(FILE,"+>$DateList");
	print FILE "DateList([".join(',',@list)."]);";
	close(FILE);
}
###
sub Analize{
	my($fn,%line,@date,%month,$line,$lineuse,$error,$nopage,$custom,$dbh,$sth,$insert);
	$fn=shift;
	return if((stat($fn))[9]<$LastUpdate || !-e($fn) || !-s($fn));
	$Info{LogPointer}=0 if(!$Info{LogPointer} || -s($fn)<$Info{LogPointer});
	%month=('Jan'=>'01','Feb'=>'02','Mar'=>'03','Apr'=>'04','May'=>'05','Jun'=>'06','Jul'=>'07','Aug'=>'08','Sep'=>'09','Oct'=>'10','Nov'=>'11','Dec'=>'12');
	if($Info{'CurrentDate'}){
		if(!-e("$DbDir$Info{'CurrentDate'}.db")){
			$dbh=DBI->connect("dbi:SQLite:dbname=$DbDir$Info{'CurrentDate'}.db");
			$dbh->do("create table Log(RowId integer primary key autoincrement,Server text,error int,custom int,code int,file text,ref text,ua text,host text,Data text)");
			$dbh->do("create index Server on Log(Server)");
			$dbh->do("create index error on Log(error)");
			$dbh->do("create index custom on Log(custom)");
			$dbh->do("create index code on Log(code)");
			$dbh->do("create index file on Log(file)");
			$dbh->do("create index ref on Log(ref)");
			$dbh->do("create index ua on Log(ua)");
			$dbh->do("create index host on Log(host)");
		}else{
			$dbh=DBI->connect("dbi:SQLite:dbname=$DbDir$Info{'CurrentDate'}.db");
		}
		$dbh->do('BEGIN');
		$sth=$dbh->prepare("insert into Log(Server,error,custom,Code,file,ref,ua,host,Data) values(?,?,?,?,?,?,?,?,?)");
	}
	open(LOG,$fn);
	seek(LOG,$Info{LogPointer},0);
	while(<LOG>){
		$line=$_;
		($line{'server'},$line{'host'},$line{'time'},$line{'method'},$line{'file'},$line{'code'},$line{'byte'},$line{'ref'},$line{'ua'})=$line=~/^([^ ]+) ([^ ]+) [^ ]+ [^ ]+ \[([^\]]+)\] "(\w+) +([^" ]+)[^"]+" (\d+) (\d+) "([^"]+)" "([^"]+)"\n/;
		next if(!$line{'server'});
		$lineuse='';
		@date=$line{'time'}=~/^(\d{2})\/(\w{3})\/(\d{4}):(\d{2}):(\d{2}):(\d{2})/;
		$date[1]=$month{$date[1]};
		if($Info{'CurrentDate'}!=($date[2].$date[1].$date[0])){
			next if($Info{'CurrentDate'}>($date[2].$date[1].$date[0]));
			if($sth){
				$sth->finish;
				$dbh->disconnect;
			}
			&WriteDate if($Info{'CurrentDate'});
			$Info{'CurrentDate'}=$date[2].$date[1].$date[0];
			if(!-e("$DbDir$Info{'CurrentDate'}.db")){
				$dbh=DBI->connect("dbi:SQLite:dbname=$DbDir$Info{'CurrentDate'}.db");
				$dbh->do("create table Log(RowId integer primary key autoincrement,Server text,error int,custom int,code int,file text,ref text,ua text,host text,Data text)");
				$dbh->do("create index Server on Log(Server)");
				$dbh->do("create index error on Log(error)");
				$dbh->do("create index custom on Log(custom)");
				$dbh->do("create index code on Log(code)");
				$dbh->do("create index file on Log(file)");
				$dbh->do("create index ref on Log(ref)");
				$dbh->do("create index ua on Log(ua)");
				$dbh->do("create index host on Log(host)");
			}else{
				$dbh=DBI->connect("dbi:SQLite:dbname=$DbDir$Info{'CurrentDate'}.db");
			}
			$dbh->do('BEGIN');
			$sth=$dbh->prepare("insert into Log(Server,error,custom,Code,file,ref,ua,host,Data) values(?,?,?,?,?,?,?,?,?)");
		}
		$line{'ref'}='-' if($line{'file'} eq '/favicon.ico');
		($line{'file'},$line{'query'})=split(/\?/,$line{'file'},2);
		($line{'se'},$line{'ss'})=&SearchEngine($line{'ref'});
		$Data{$line{'server'}}{'file'}{$line{file}}++;
		$Data{$line{'server'}}{'access'}++;
		$Data{$line{'server'}}{'host'}{$line{'host'}}++;
		$Data{$line{'server'}}{"hour-$date[3]"}++;
		$Data{$line{'server'}}{"byte"}+=$line{'byte'};
		$Data{$line{'server'}}{'code'}{$line{'code'}}++;
		$error=0;
		if(substr($line{'code'},0,1) eq '5' || substr($line{'code'},0,1) eq '4'){
			$error=1;
			for(my $i=0;$i<=$#{$Conf{'noerror'}};$i++){
				if($Conf{'noerror'}[$i][1] eq '=='){
					$error=0 if($line{$Conf{'noerror'}[$i][0]} eq $Conf{'noerror'}[$i][2]);
				}elsif($Conf{'noerror'}[$i][1] eq '=~'){
					$error=0 if($line{$Conf{'noerror'}[$i][0]}=~/$Conf{'noerror'}[$i][2]/);
				}
			}
			if($error){
				$Data{$line{'server'}}{'error'}++;
				$lineuse=1;
			}
		}
		$custom=0;
		if(defined($Conf{'custom'})){
			if($Conf{'custom'}[2] eq '=='){
				if($line{$Conf{'custom'}[1]} eq $Conf{'custom'}[3]){
					$Data{$line{'server'}}{'custom'}{$Conf{'custom'}[0]}++;
					$lineuse=1;
					$custom=1;
				}
			}elsif($Conf{'custom'}[2] eq '=~'){
				if($line{$Conf{'custom'}[1]}=~/$Conf{'custom'}[3]/){
					$Data{$line{'server'}}{'custom'}{$Conf{'custom'}[0]}++;
					$lineuse=1;
					$custom=1;
				}
			}
		}
		if($line{'se'}){
			$line{'ss'}=lc($line{'ss'});
			$line{'ss'}=~s/\%e3%80%80/\+/g;
			$line{'ss'}=~s/\%20/\+/g;
			$line{'ss'}=~s/\+/ /g;
			$line{'ss'}=~s/ +/ /g;
			$line{'ss'}=~s/^ //;
			$line{'ss'}=~s/ $//;
			$Data{$line{'server'}}{"se"}{$line{'se'}}++;
			$Data{$line{'server'}}{"ss"}{$line{'ss'}}++;
			foreach(split(/ /,$line{'ss'})){
				$Data{$line{'server'}}{"sw"}{$_}++;
			}
		}
		if($line{'ref'}=~/https?:\/\/([^\/]+)/){
			$line{'ref'}=$1;
		}
		$Data{$line{'server'}}{'ref'}{$line{'ref'}}++;
		($line{'ua'},$line{'bot'})=&AgentGroup($line{'ua'});
		if($line{'method'} eq 'GET' || $line{'method'} eq 'POST'){
			if($line{'code'}==200 || $line{'code'}==304){
				foreach(@{$Conf{'page'}}){
					if($line{'file'}=~/$_$/){
						$nopage=0;
						foreach(@{$Conf{'nopage'}{$line{'server'}}}){
							if($line{'file'}=~/$_/){
								$nopage=1;
								last;
							}
						}
						if(!$nopage){
							$Data{$line{'server'}}{'page'}++;
							$Data{$line{'server'}}{'bot'}++ if($line{'bot'});
						}
						last;
					}
				}
			}
		}
		$Data{$line{'server'}}{'ua'}{$line{'ua'}}++;
		if(!$InsertType || ($error || $custom)){
			$sth->execute($line{'server'},$error,$custom,$line{'code'},$line{'file'},$line{'ref'},$line{'ua'},$line{'host'},$line);
			$insert++;
			if($insert>10000){
				$dbh->do('COMMIT');
				$dbh->do('BEGIN');
				$insert=0;
			}
		}
	}
	$Info{LogPointer}=tell(LOG);
	close(LOG);
	$Info{LogPointer}=0 if($fn eq $Logfile2 && -s($Logfile1));
	if($sth){
		$dbh->do('COMMIT');
		$sth->finish;
		$dbh->disconnect;
	}
}
###
sub AgentGroup{
	my($ua);
	$ua=shift;
	return("MSIE $1.x") if($ua=~/MSIE (\d+)\.\d/);
	return("Google Chrome $1.x") if($ua=~/Chrome\/(\d+)\.\d/);
	return("Firefox $1.x") if($ua=~/Firefox\/(\d+)\.\d/);
	return("Safari $1.x") if($ua=~/Version\/(\d+)\.\d[^\)]+Safari\/\d+\.\d/);
	return("Opera $1.x") if($ua=~/Opera[ \/](\d+)\.\d/);
	return("Netscape $1.x") if($ua=~/Netscape\/(\d+)\.\d/);

	return("Googlebot",1) if($ua=~/[gG]ooglebot/);
	return("Yahoo! Slurp",1) if($ua=~/Yahoo! Slurp/);
	return("Baiduspider",1) if($ua=~/^Baiduspider/);
	return("MSNBot",1) if($ua=~/^msnbot/);
	return("NaverBot",1) if($ua=~/^Yeti/);
	return("YandexBot",1) if($ua=~/YandexBot/);
	return("AMZNKAssocBot",1) if($ua=~/AMZNKAssocBot/);
	return("Hatena Antenna",1) if($ua=~/Hatena Antenna/);
	return("LWP",1) if($ua=~/^libwww\-perl/);

	return("DoCoMo/$1.x") if($ua=~/^DoCoMo\/(\d+)\.\d/);
	return("SoftBank/$1.x") if($ua=~/^SoftBank\/(\d+)\.\d/);
	return("UP.Browser/$1.x") if($ua=~/UP\.Browser\/(\d+)\.\d/);
	return("jig browser $1.x") if($ua=~/jig browser web; (\d+)\.\d/);
	return("NetFront/$1.x") if($ua=~/NetFront\/(\d+)\.\d/);

	return("PlayStation 3") if($ua=~/PLAYSTATION 3/);

	return("KHTML") if($ua=~/KHTML/);
	return("Gecko") if($ua=~/Gecko/);

	return($ua);
}
###
sub SearchEngine{
	my($url);
	$url=shift;
	return('Google',$1) if($url=~/^http:\/\/[^\/]+\.google\.[^\/]+\/.*\Wq=([\w\%\-\.\~\+]+)/);
	return('Yahoo!',$1) if($url=~/^http:\/\/[^\/]+\.yahoo\.[^\/]+\/.*\Wp=([\w\%\-\.\~\+]+)/);
	return('bing',$1) if($url=~/^http:\/\/[^\/]+\.bing\.[^\/]+\/.*\Wq=([\w\%\-\.\~\+]+)/);
	return('Baidu',$1) if($url=~/^http:\/\/[^\/]+\.baidu\.[^\/]+\/.*\Wwd=([\w\%\-\.\~\+]+)/);
	return('NAVER',$1) if($url=~/^http:\/\/[^\/]+\.naver\.[^\/]+\/.*\Wq=([\w\%\-\.\~\+]+)/);
	return('@nifty',$1) if($url=~/^http:\/\/[^\/]+\.nifty\.[^\/]+\/.*\Wq=([\w\%\-\.\~\+]+)/);
	return('excite',$1) if($url=~/^http:\/\/[^\/]+\.excite\.[^\/]+\/.*\Wsearch=([\w\%\-\.\~\+]+)/);
	return('livedoor',$1) if($url=~/^http:\/\/[^\/]+\.livedoor\.[^\/]+\/.*\Wq=([\w\%\-\.\~\+]+)/);
	return('goo',$1) if($url=~/^http:\/\/[^\/]+\.goo\.[^\/]+\/.*\WMT=([\w\%\-\.\~\+]+)/);
#	return('JWord',$1) if($url=~/^http:\/\/[^\/]+\.jword\.[^\/]+\/.*\Wq=([\w\%\-\.\~\+]+)/);
}
###
sub WriteDate{
	my($data,@all,@keys,@data,$i,$j,$k,$l,$key,$count,$fn,$dir);
	foreach $i(keys(%Data)){
		undef(@keys);
		foreach $j(keys(%{$Data{$i}})){
			undef(@data);
			if(ref($Data{$i}{$j})){
				$count=0;
				foreach $k( sort {$Data{$i}{$j}{$b} <=> $Data{$i}{$j}{$a}} keys(%{$Data{$i}{$j}}) ){
					$key=$k;
					$key=~s/([\\'])/\\$1/g;
					push(@data,"'$key':$Data{$i}{$j}{$k}");
					$count++;
					last if($count==$MaxList);
				}
				push(@keys,"'$j':{".join(',',@data).'}');
			}else{
				push(@keys,"'$j':$Data{$i}{$j}");
			}
		}
		push(@keys,"'unique':".scalar(keys(%{$Data{$i}{host}})));
		$key=$i;
		$key=~s/([\\'])/\\$1/g;
		push(@all,"'$key':{".join(',',@keys).'}');
	}
	$data.="DateData({".join(',',@all)."});\n";
	open(FILE,"+>${DataDir}$Info{'CurrentDate'}.jgz");
	print FILE Compress::Zlib::memGzip($data);
	close(FILE);
	foreach $dir(($DataDir,$DbDir)){
		opendir(DIR,$dir);
		foreach $fn(readdir(DIR)){
			unlink($dir.$fn) if(-M($dir.$fn)>$LogExpires);
		}
		closedir(DIR);
	}
	undef(%Data);
}
###

